#!/usr/bin/perl
# -- lyrics retrieval script for xmms
# -- 04/2004 by camico A7 users D07 sourceforge D07 net

use LWP::Simple qw(get);
eval "use Encode qw(from_to)"; $ENCODE_LOADED = not $@;
my $lyrdir = shift;
DBG( "Artist: $artist\nTitle:  $title" );

# =============================================================================
my $DEBUG = 1;

my $CACHE_DAYS = 30;
my $CACHE = "$lyrdir/sing365.com/";
# =============================================================================

my $sep = "__00__";
my $string = join( " ", @ARGV );
my @info = split / $sep /, $string;
my $artist = $info[0];
my $title = $info[1];
my $realtitle = $info[1];
my $lyrfile = $lyrdir.$artist." - ".$title.".lyrics.xml";
my $cachefile = $CACHE.(lc $artist).".links.html";
# -----------------------------------------------------------------------------
my $urlhead  = "http://search.sing365.com/";
my $urlhead2 = "http://www.sing365.com/";
my $html = "";
DBG( "Artist: $artist\nTitle:  $title" );
DBG( "install Perl module \"Encode\" to reduce character (mainly apostroph) errors..." )
    if not $ENCODE_LOADED;

# see if another title was selected manually
# ------------------------------
if( open INFO, "<$lyrdir/$artist - $title.info" ) {
    my $lastline = "";
    while( $line = <INFO> ) {
        chomp($line);
        if( $lastline eq "SONG" ) {
            $realtitle = $line;
            last;
        }
        $lastline = $line;
    } close INFO;
	#DBG( "real song name is: $realtitle" );
}

# 0. look at cache
# ------------------------------
if( $CACHE && ( (-d $CACHE && -w $CACHE) || mkdir( $CACHE ) ) ) {
    if( -M $cachefile < $CACHE_DAYS ) {
	if( open CACHE, "<$cachefile" ) {
	    while( $line = <CACHE> ) {
		$html .= $line;
	    } close CACHE;
	    DBG( "using cached lyrics list (age = ".(sprintf("%.2f days", (-M $cachefile))).")" );
	    if( $html eq "NOTFOUND" ) { notfound( "Artist not found." ); }
	}
    } else { DBG( "renewing cache for $artist (age = ".(-M $cachefile).")" ); }
}
if( not $html ) {
    # 1. artist search
    # ------------------------------
    $artist_url = $artist;
    $artist_url =~ s/\'/ /g;
    $artist_url =~ s/ /+/g;
    $url = $urlhead."search.php?searchstr=".$artist_url."&category=artist&x=0&y=0";
    $html = get $url;
    notfound("Cannot access $url.") if not $html;

    @url      = ($html =~ /(click\.php\?id.*?)>/gs);
    @linkname = ($html =~ /click.php.*?=1>(.*?)<\/font><\/a>/gis);
    $hits = @url;
    if( not $hits ) {
	write_cache( "NOTFOUND" );
	notfound("Artist not found.");
    }
    DBG( "artist hits: [".join(", ", @linkname)."]" );

    # take the first artist link
    $url = $urlhead.$url[0];
    # and correct it if another one is a better match
    for( $i=0; $i<@linkname; $i++ ) {
	if( $linkname[$i] =~ /$artist/i ) {
	    $url = $urlhead.$url[$i];
	    last;
	}
    }
    DBG( "artist link: $url ");

    # 2. all lyrics
    # ------------------------------
    $html = get $url;
    $html =~ /(music\/lyric.*?)\"?>Lyrics<\/a>/i;
    $url = $urlhead2.$1;
    DBG( "all lyrics:  $url");

    $html = get $url;
    write_cache( $html );
}

# 3. look for title
# ------------------------------
$matchtitle1 = $realtitle;
$matchtitle1 =~ s/\?|,|\!|=|\+|\:|\.$//g;
$matchtitle1 =~ s/ |\.|\(|\)/-/g;
while( $matchtitle1 =~ /--/ ) { $matchtitle1 =~ s/--/-/g; }
while( $matchtitle1 =~ /-$/ ) { $matchtitle1 =~ s/-$//; }
$matchtitle2 = $matchtitle1;
$matchtitle2 =~ s/\'//g;
$matchtitle3 = $matchtitle1;
$matchtitle3 =~ s/\'/-acute-/g;

DBG( "trying with: $matchtitle1" );
if( $html =~ /(music\/lyric\.nsf\/$matchtitle1-lyrics.*?)\"?>/i ||
    $html =~ /(music\/lyric\.nsf\/$matchtitle2-lyrics.*?)\"?>/i ||
    $html =~ /(music\/lyric\.nsf\/$matchtitle3-lyrics.*?)\"?>/i ) {
    $url = $urlhead2.$1;
    DBG( "lyrics link: $url ");

    $html = get $url;
    $titlestart = substr( $realtitle, 0, 3 );
    if( $html =~ /(<B>(?i)$titlestart.*?)<hr/s ) {
	$lyrics = $1;
	$lyrics =~ s/(\n|\nSponsored Link: )<a.*?\/a>//gis; # remove links with contents
	$lyrics =~ s/<.*?>//gis;       # remove all tags
	$lyrics =~ s/\n?document.*?\);\n?//gis;       # remove JS
	$lyrics =~ s/.*?Print the Lyrics\)//gs;
	$lyrics =~ s/.*?$realtitle Lyrics//gis;
	Encode::from_to( $lyrics, "utf8", "latin9" ) if $ENCODE_LOADED;
	$lyrics =~ s/\?(\w)/\'$1/g;    # replace unknown chars with '
	#$lyrics = linebreak( $lyrics );
	DBG( "Lyrics: $lyrics" );
    } elsif( $html =~ /sorry, i have no/i ) {
		notfound("Lyrics are not there.");
    } else {
		notfound("Lyrics are there, but I am too dumb to get them :(");
    }
} else {
    DBG( "lyrics link not there" );
    @artist_songs = ( $html =~ /music\/lyric\.nsf\/.*?-lyrics-.*? - (.*?) Lyrics/ig );
    write_result_list();
  # notfound("lyrics link not there");
}

# Success
# -----------------------------------------------------------------------------
if( substr( $lyrics, 0, 1 ) eq "\n" ) { $lyrics = substr( $lyrics, 1 ); }
open FILE, ">:utf8", $lyrfile;
print FILE <<STOP;
<?xml version="1.0" encoding="utf-8" ?>
    <lyrc><result>
    <name>$realtitle</name>
    <group>$artist</group>
    <lyric>$lyrics</lyric>
    </result></lyrc>
STOP
close FILE;
exit;

# -----------------------------------------------------------------------------
sub write_result_list {
	my $err = shift;
	$err =~ s/\&/\&amp;/g;
    DBG( "artist's songs:" );

    open FILE, ">:utf8", $lyrfile;
    print FILE '<?xml version="1.0" encoding="utf-8" ?><lyrc><suggest>';
    foreach( @artist_songs ) {
        $name = $_;
        $name =~ s/&/And/;
        print FILE '<song><name>'.$name.'</name><group>'.$artist.'</group></song>';
    }
	if( $err ) { print FILE '<message>'.$err.'</message>'; }
    print FILE '</suggest></lyrc>';
    close FILE;
    exit;
}

# -----------------------------------------------------------------------------
sub notfound {
    my $err = shift;
    DBG( "lyrics for \"$artist - $title\" not found :( ... [$err]" );
	write_result_list( $err );
#    if( $ALT_SCRIPT ) {
#		$path = substr( $0, 0, rindex( $0, '/') );
#		$string = escape( $string );
#		DBG( "Executing 2. script: $path/$ALT_SCRIPT $lyrdir $string" );
#		system( "$path/$ALT_SCRIPT $lyrdir $string" );
#	} else {
#	    open FILE, ">$lyrfile";
#	    close FILE;
#   }
    exit;
}
# -----------------------------------------------------------------------------
# sub linebreak {
#     my $lyr = shift;
#     @lines = split /\n/, $lyr;
#     $lyr = "";
# 
#     foreach( @lines ) {
# 	if( length($_) > $BREAK ) {
# 	    $line = $_;
# 	    while( length( $line ) > $BREAK ) {
# 		$cut = rindex( $line, ".", $BREAK );
# 		$cut = rindex( $line, "?", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, "!", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, "\"", $BREAK ) if $cut < 0;
# 		$cut = rindex( $line, " ", $BREAK ) if $cut < 0;
# 		$cut = $BREAK if $cut < 0;
# 		$cut++;
# 		$attach = substr( $line, 0, $cut ) . "\n";
# #		$attach =~ s/^[ ]*//;
# 		$lyr .= $attach;
# 		$line = substr( $line, $cut );
# 	    }
# 	    $lyr .= $line . "\n";
# 	} else {
# 	    $lyr .= $_ . "\n";
# 	}
#     }
#     return $lyr;
# }
# -----------------------------------------------------------------------------
sub write_cache {
    my $html = shift;
    unlink $cachefile;

    if( open CACHE, ">$cachefile" ) {
	@lines = split /\n/, $html;
	foreach( @lines ) {
	    if( $_ =~ /music\/lyric\.nsf\/.*-lyrics.*\"?>/i || $_ eq "NOTFOUND" ) {
		print CACHE $_;
	    }
	}
	close CACHE;
    } else {
	DBG( "Can't save list to \"$cachefile\"" );
    }

}
# -----------------------------------------------------------------------------
sub escape {
    $str = shift;
#    $str =~ s/ /\\\ /g;
    $str =~ s/'/\\'/g; 
    $str =~ s/\(/\\(/g;   
    $str =~ s/\)/\\)/g;
    $str =~ s/\&/\\&/g;    
    $str =~ s/\;/\\;/g;
    $str =~ s/\[/\\[/g;
    $str =~ s/\]/\\]/g;
    return $str;
}
# -----------------------------------------------------------------------------
sub DBG {
    my $str = shift;
    if( $DEBUG ) {
	$str =~ s/\n/\n       /g;
	print "[Lyrc] $str\n";
    }
}
